import { JsonPipe } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import { RxFor } from '@rx-angular/template/for';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import * as i3 from '@smallstack/common-components';
import { OverlayComponent } from '@smallstack/common-components';
import { filterNullish } from '@smallstack/utils';
import { WidgetRendererComponent } from '@smallstack/widget-core';
import { map, switchMap } from 'rxjs';
import { B as BaseViewWidgetComponent } from './smallstack-data-widgets-base-view-widget.component-19f20763.mjs';

class ArrayViewWidgetComponent extends BaseViewWidgetComponent {
    constructor(schemaService) {
        super();
        this.schemaService = schemaService;
        this.count$ = this.model$.pipe(map((context) => {
            if (Array.isArray(context))
                return context.length;
            return 0;
        }));
        this.itemSchema$ = this.schema$.pipe(filterNullish(), map((schema) => schema.items), switchMap((schema) => this.schemaService.evalRefSchema(schema)));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: ArrayViewWidgetComponent, deps: [{ token: i3.FrontendSchemaService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: ArrayViewWidgetComponent, isStandalone: true, selector: "smallstack-array-view-widget", usesInheritance: true, ngImport: i0, template: "<span *rxLet=\"count$; let count\" class=\"border-dashed border-b cursor-pointer\" (click)=\"overlay.openOverlay()\">\n  {{ count }} {{ count === 1 ? \"Eintrag\" : \"Eintr\u00E4ge\" }}</span\n>\n<smallstack-overlay #overlay>\n  <div class=\"flex flex-col gap-1 card card-bordered bg-white shadow-lg p-1 overflow-auto\">\n    <div *rxFor=\"let item of model$; let index = index\" class=\"flex flex-row gap-1\">\n      <span class=\"font-bold p-1\">#{{ index + 1 }}</span>\n      <smallstack-widget-renderer\n        [widget]=\"{ name: 'DefaultDetailsView' }\"\n        [context]=\"{ model: item, schema: itemSchema$ | push }\"\n      ></smallstack-widget-renderer>\n    </div>\n  </div>\n</smallstack-overlay>\n", dependencies: [{ kind: "directive", type: RxLet, selector: "[rxLet]", inputs: ["rxLet", "rxLetStrategy", "rxLetComplete", "rxLetError", "rxLetSuspense", "rxLetContextTrigger", "rxLetCompleteTrigger", "rxLetErrorTrigger", "rxLetSuspenseTrigger", "rxLetNextTrigger", "rxLetRenderCallback", "rxLetParent", "rxLetPatchZone"], outputs: ["rendered"] }, { kind: "pipe", type: RxPush, name: "push" }, { kind: "directive", type: RxFor, selector: "[rxFor][rxForOf]", inputs: ["rxForOf", "rxForTemplate", "rxForStrategy", "rxForParent", "rxForPatchZone", "rxForTrackBy", "rxForRenderCallback"] }, { kind: "component", type: OverlayComponent, selector: "smallstack-overlay", inputs: ["hasBackdrop"] }, { kind: "component", type: WidgetRendererComponent, selector: "smallstack-widget-renderer", inputs: ["widget", "additionalProviders", "context", "class"], outputs: ["widgetChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: ArrayViewWidgetComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-array-view-widget", standalone: true, imports: [RxLet, RxPush, RxFor, OverlayComponent, WidgetRendererComponent, JsonPipe], changeDetection: ChangeDetectionStrategy.OnPush, template: "<span *rxLet=\"count$; let count\" class=\"border-dashed border-b cursor-pointer\" (click)=\"overlay.openOverlay()\">\n  {{ count }} {{ count === 1 ? \"Eintrag\" : \"Eintr\u00E4ge\" }}</span\n>\n<smallstack-overlay #overlay>\n  <div class=\"flex flex-col gap-1 card card-bordered bg-white shadow-lg p-1 overflow-auto\">\n    <div *rxFor=\"let item of model$; let index = index\" class=\"flex flex-row gap-1\">\n      <span class=\"font-bold p-1\">#{{ index + 1 }}</span>\n      <smallstack-widget-renderer\n        [widget]=\"{ name: 'DefaultDetailsView' }\"\n        [context]=\"{ model: item, schema: itemSchema$ | push }\"\n      ></smallstack-widget-renderer>\n    </div>\n  </div>\n</smallstack-overlay>\n" }]
        }], ctorParameters: function () { return [{ type: i3.FrontendSchemaService }]; } });

export { ArrayViewWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-array-view-widget.component-3089f03d.mjs.map
