import { JsonPipe } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import { RxIf } from '@rx-angular/template/if';
import { RxPush } from '@rx-angular/template/push';
import { manipulateData } from '@smallstack/client-common';
import { I18nComponent } from '@smallstack/i18n-components';
import { IconComponent } from '@smallstack/theme-components';
import { filterNullish, cloneObject } from '@smallstack/utils';
import { BaseWidgetComponent, WidgetChildComponent } from '@smallstack/widget-core';
import { combineLatest, map } from 'rxjs';

class ContextManipulationWidgetComponent extends BaseWidgetComponent {
    constructor() {
        super(...arguments);
        this.innerContext$ = combineLatest([this.context$, this.data$]).pipe(filterNullish(), map(([context, data]) => {
            context = context || {};
            return manipulateData(context, data.actions);
        }));
    }
    addWidget(widget) {
        if (this.data === undefined)
            this.data = {};
        this.data.child = cloneObject(widget);
        this.dataChange.emit(this.data);
    }
    childDataChanged(cmsComponent) {
        if (!cmsComponent)
            this.data.child = undefined;
        else
            this.data.child.data = cmsComponent.data;
        this.dataChange.emit(this.data);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: ContextManipulationWidgetComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: ContextManipulationWidgetComponent, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<smallstack-widget-child\n  [(data)]=\"data\"\n  (dataChange)=\"dataChange.emit($event)\"\n  [context]=\"innerContext$ | push\"\n  property=\"child\"\n></smallstack-widget-child>\n\n<div *rxIf=\"!data.child\" style=\"height: 100%; padding: 12px\" class=\"flex flex-col justify-center items-center\">\n  <smallstack-icon alias=\"warning\" size=\"48\"></smallstack-icon>\n  <p style=\"text-align: center\"\n    ><smallstack-i18n data=\"@@dashboard.widgets.contextcontainer.notemplatedefined\"></smallstack-i18n\n  ></p>\n</div>\n", dependencies: [{ kind: "directive", type: RxIf, selector: "[rxIf]", inputs: ["rxIf", "rxIfStrategy", "rxIfElse", "rxIfThen", "rxIfSuspense", "rxIfComplete", "rxIfError", "rxIfContextTrigger", "rxIfNextTrigger", "rxIfSuspenseTrigger", "rxIfErrorTrigger", "rxIfCompleteTrigger", "rxIfParent", "rxIfPatchZone", "rxIfRenderCallback"] }, { kind: "pipe", type: RxPush, name: "push" }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "component", type: WidgetChildComponent, selector: "smallstack-widget-child", inputs: ["data", "context", "property", "widgetTags"], outputs: ["dataChange"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: ContextManipulationWidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [RxIf, RxPush, IconComponent, I18nComponent, WidgetChildComponent, JsonPipe], template: "<smallstack-widget-child\n  [(data)]=\"data\"\n  (dataChange)=\"dataChange.emit($event)\"\n  [context]=\"innerContext$ | push\"\n  property=\"child\"\n></smallstack-widget-child>\n\n<div *rxIf=\"!data.child\" style=\"height: 100%; padding: 12px\" class=\"flex flex-col justify-center items-center\">\n  <smallstack-icon alias=\"warning\" size=\"48\"></smallstack-icon>\n  <p style=\"text-align: center\"\n    ><smallstack-i18n data=\"@@dashboard.widgets.contextcontainer.notemplatedefined\"></smallstack-i18n\n  ></p>\n</div>\n" }]
        }] });

export { ContextManipulationWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-context-manipulation-widget.component-a081e191.mjs.map
