import * as i10 from '@angular/cdk/scrolling';
import { CdkVirtualScrollViewport, ScrollingModule } from '@angular/cdk/scrolling';
import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Inject, Input, HostBinding, ViewChild } from '@angular/core';
import * as i2$1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i7 from '@angular/google-maps';
import { GoogleMapsModule } from '@angular/google-maps';
import * as i8 from '@angular/material/card';
import { MatCardModule } from '@angular/material/card';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import { MatSortModule } from '@angular/material/sort';
import { MatTableModule } from '@angular/material/table';
import * as i5 from '@angular/router';
import { FixedSizeVirtualScrollStrategy, RxVirtualScrollViewportComponent, RxVirtualFor } from '@rx-angular/template/experimental/virtual-scrolling';
import { RxFor } from '@rx-angular/template/for';
import { RxIf } from '@rx-angular/template/if';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import * as i3 from '@smallstack/common-components';
import { FlattenPipe, JsonByPathPipe, JsonStringPipe, LoadingElementDirective, ObjectArrayValuePipe, OverlayComponent, LongPressDirective, CloseDropDownOnClickDirective, ResizeColumnDirective, UppercaseSpacePipe, LetDirective, NgForTrackByIdDirective, RenderInViewportDirective, DebugComponentComponent, ScrollableDirective } from '@smallstack/common-components';
import * as i2 from '@smallstack/i18n-components';
import { I18nComponent, CurrencyComponent, DateComponent, DurationComponent } from '@smallstack/i18n-components';
import { QRCodeDialogComponent } from '@smallstack/qrcode-components';
import { LoaderComponent, StorePropertyComponent, ListContainerComponent, MatSortStoreDirective } from '@smallstack/store-components';
import { MarkdownViewerComponent } from '@smallstack/text-components';
import { IconComponent } from '@smallstack/theme-components';
import * as i1$1 from '@smallstack/typesystem-client';
import { ShowForPermissionDirective } from '@smallstack/user-components';
import { filterNullish, distinctUntilChangedObj, convertSortStringToAscDesc, throttleInput, removeNullish, sortStringWithNumbers, getJsonByPath, getSchemaPropertiesKeys, when, isEmptyObject, removeRequired, convertGeoPointToLatLng, convertToSortString, setJsonProperty, onlyUnique } from '@smallstack/utils';
import { WidgetTreeComponent, BaseWidgetComponent, WidgetTag, WidgetDialogComponent, WidgetChildComponent, FormComponent } from '@smallstack/widget-core';
import Fuse from 'fuse.js';
import { switchMap, shareReplay, map, of, BehaviorSubject, combineLatest, startWith, pairwise, firstValueFrom } from 'rxjs';

class DataTableV3DialogComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        data.widgetRendererOptions.dialogRef = dialogRef;
    }
    close() {
        if (this.data.widgetRendererOptions?.editMode === true)
            this.dialogRef.close(this.data.cmsComponent);
        else
            this.dialogRef.close();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: DataTableV3DialogComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: DataTableV3DialogComponent, isStandalone: true, selector: "ng-component", ngImport: i0, template: "<div mat-dialog-content>\n  <smallstack-widget-tree\n    [(widget)]=\"data.cmsComponent\"\n    [widgetRendererOptions]=\"data.widgetRendererOptions\"\n    [context]=\"data.context\"\n  ></smallstack-widget-tree>\n</div>\n<div mat-dialog-actions class=\"flex flex-row justify-end\">\n  <button (click)=\"close()\" class=\"btn btn-primary\">\n    <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n  </button>\n</div>\n", styles: [".mat-mdc-dialog-content{height:calc(100% - 40px);max-height:unset}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "component", type: WidgetTreeComponent, selector: "smallstack-widget-tree", inputs: ["widgetRendererOptions", "widget", "context", "globals", "connections", "rootSockets"], outputs: ["connectionsChange", "widgetChange"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "ngmodule", type: MatDialogModule }, { kind: "directive", type: i1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: DataTableV3DialogComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [CommonModule, WidgetTreeComponent, I18nComponent, MatDialogModule], template: "<div mat-dialog-content>\n  <smallstack-widget-tree\n    [(widget)]=\"data.cmsComponent\"\n    [widgetRendererOptions]=\"data.widgetRendererOptions\"\n    [context]=\"data.context\"\n  ></smallstack-widget-tree>\n</div>\n<div mat-dialog-actions class=\"flex flex-row justify-end\">\n  <button (click)=\"close()\" class=\"btn btn-primary\">\n    <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n  </button>\n</div>\n", styles: [".mat-mdc-dialog-content{height:calc(100% - 40px);max-height:unset}\n"] }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i1.MatDialogRef }]; } });

class SortIconComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: SortIconComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: SortIconComponent, isStandalone: true, selector: "smallstack-sort-icon", inputs: { propertyName: "propertyName", sorting: "sorting", defaultSorting: "defaultSorting" }, ngImport: i0, template: "<div *rxIf=\"sorting?.propertyName === propertyName\" class=\"w-4 h-4 center-center\">\n  <!-- default? -->\n  <ng-container\n    *rxIf=\"\n      sorting.propertyName === defaultSorting.propertyName && sorting.direction === defaultSorting.direction;\n      else showNormal\n    \"\n  >\n    <ng-container *rxIf=\"sorting.direction === 'asc'\">\u25BD</ng-container>\n    <ng-container *rxIf=\"sorting.direction === 'desc'\">\u25B3</ng-container>\n  </ng-container>\n  <ng-template #showNormal>\n    <ng-container *rxIf=\"sorting.direction === 'asc'\">\u25BC</ng-container>\n    <ng-container *rxIf=\"sorting.direction === 'desc'\">\u25B2</ng-container>\n  </ng-template>\n</div>\n", dependencies: [{ kind: "directive", type: RxIf, selector: "[rxIf]", inputs: ["rxIf", "rxIfStrategy", "rxIfElse", "rxIfThen", "rxIfSuspense", "rxIfComplete", "rxIfError", "rxIfContextTrigger", "rxIfNextTrigger", "rxIfSuspenseTrigger", "rxIfErrorTrigger", "rxIfCompleteTrigger", "rxIfParent", "rxIfPatchZone", "rxIfRenderCallback"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: SortIconComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-sort-icon", standalone: true, imports: [RxIf, IconComponent], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div *rxIf=\"sorting?.propertyName === propertyName\" class=\"w-4 h-4 center-center\">\n  <!-- default? -->\n  <ng-container\n    *rxIf=\"\n      sorting.propertyName === defaultSorting.propertyName && sorting.direction === defaultSorting.direction;\n      else showNormal\n    \"\n  >\n    <ng-container *rxIf=\"sorting.direction === 'asc'\">\u25BD</ng-container>\n    <ng-container *rxIf=\"sorting.direction === 'desc'\">\u25B3</ng-container>\n  </ng-container>\n  <ng-template #showNormal>\n    <ng-container *rxIf=\"sorting.direction === 'asc'\">\u25BC</ng-container>\n    <ng-container *rxIf=\"sorting.direction === 'desc'\">\u25B2</ng-container>\n  </ng-template>\n</div>\n" }]
        }], propDecorators: { propertyName: [{
                type: Input
            }], sorting: [{
                type: Input
            }], defaultSorting: [{
                type: Input
            }] } });

const FULL_TEXT_SEARCH_HEIGHT = 48;
class DataTableV3WidgetComponent extends BaseWidgetComponent {
    constructor(matDialog, notificationService, routerUtilService, frontendTypeRegistry, breakPointService, rxCollectionService, schemaService, activatedRoute) {
        super();
        this.matDialog = matDialog;
        this.notificationService = notificationService;
        this.routerUtilService = routerUtilService;
        this.frontendTypeRegistry = frontendTypeRegistry;
        this.breakPointService = breakPointService;
        this.rxCollectionService = rxCollectionService;
        this.schemaService = schemaService;
        this.activatedRoute = activatedRoute;
        this.height = "100%";
        this.SEARCH_RESULT_SCORE_SORT = "__SEARCH_RESULTS_SCORE";
        this.collection$ = this.data$.pipe(filterNullish({ filterEmptyObjects: true }), switchMap((data) => {
            if (!data || !data.typeName)
                return undefined;
            return this.rxCollectionService.getCollection$(data.typeName);
        }), filterNullish(), switchMap(async (collection) => {
            if (!collection)
                return undefined;
            this.isLoading$.next(true);
            await collection.replicationState.awaitInSync();
            return collection;
        }), shareReplay(1));
        // data
        this.listProperties$ = this.data$.pipe(map((tableConfiguration) => {
            return tableConfiguration?.listProperties;
        }), distinctUntilChangedObj(), shareReplay(1));
        this.columns$ = this.data$.pipe(filterNullish(), switchMap((tableConfiguration) => {
            if (!tableConfiguration.listProperties)
                return this.smallstackType$.pipe(map((type) => type?.searchableFields?.map((sf) => sf.name) ?? []));
            const columns = tableConfiguration.listProperties.map((lp) => lp.columnName);
            if (this.data?.showEditButton || this.data?.showDeleteButton)
                columns.push("actions");
            if (this.data?.allowMultiDelete || this.data?.showCheckboxes)
                columns.splice(0, 0, "multiSelect");
            return of(columns);
        }), shareReplay(1));
        this.userSorting$ = new BehaviorSubject(undefined);
        this.defaultSorting$ = this.data$.pipe(filterNullish(), map((data) => {
            if (data.initialSortProperty) {
                const sort = convertSortStringToAscDesc(data.initialSortProperty);
                return { propertyName: sort.key, direction: sort.direction };
            }
            else
                return { propertyName: "id", direction: "asc" };
        }));
        this.searchTextInput$ = new BehaviorSubject(undefined);
        this.searchText$ = this.searchTextInput$.pipe(throttleInput(800));
        this.sorting$ = combineLatest([
            this.userSorting$,
            this.activatedRoute.queryParams.pipe(map((params) => params.sort)),
            this.searchText$.pipe(startWith(undefined), pairwise())
        ]).pipe(switchMap(([userSorting, urlSorting, [searchTextPrev, searchTextCurrent]]) => {
            // if search text changed, then we're sorting after search score
            if (searchTextPrev !== searchTextCurrent)
                return of({ propertyName: this.SEARCH_RESULT_SCORE_SORT, direction: "asc" });
            // if user did sort manually, use that
            if (userSorting)
                return of(userSorting);
            // if url sorting is active, use that
            if (urlSorting) {
                const sort = convertSortStringToAscDesc(urlSorting);
                return of({ propertyName: sort.key, direction: sort.direction });
            }
            // else return default sorting
            else
                return this.defaultSorting$;
        }), distinctUntilChangedObj(), shareReplay(1));
        this.totalCount$ = this.collection$.pipe(switchMap((collection) => collection.rxCollection.find().exec()), // count() does count deleted ones as well (facepalm)
        map((values) => values.length), shareReplay(1));
        this.filterSearch$ = new BehaviorSubject({});
        this.filterBarVisible$ = new BehaviorSubject(false);
        this.tableData$ = combineLatest([
            this.collection$,
            this.filterSearch$.pipe(throttleInput(1000))
        ]).pipe(switchMap(([collection, filterSearch]) => {
            if (!collection)
                return [];
            let selector = undefined;
            filterSearch = removeNullish(filterSearch, { removeEmptyObjects: true, removeEmptyStrings: true });
            if (filterSearch) {
                const filters = Object.values(filterSearch);
                if (filters.length > 0) {
                    selector = { $and: Object.values(filterSearch) };
                    selector = removeNullish(selector, { removeEmptyStrings: true, removeEmptyObjects: true });
                }
            }
            if (selector)
                return collection.rxCollection.find({ selector }).$;
            else
                return collection.rxCollection.find().$;
        }), map((values) => values.map((val) => val.toJSON())), switchMap((values) => combineLatest([of(values), this.sorting$, this.listProperties$])), map(([values, sorting, listProperties]) => {
            if (!sorting)
                return values;
            else {
                const sortingMode = listProperties?.find((lp) => lp.columnName === sorting.propertyName)?.sortingMode || "asStrings";
                if (sortingMode === "asNumbers")
                    return sortStringWithNumbers(values, { subProperty: sorting.propertyName, direction: sorting.direction });
                else
                    return values.sort((a, b) => {
                        const aProp = getJsonByPath(a, sorting.propertyName);
                        const bProp = getJsonByPath(b, sorting.propertyName);
                        if (aProp === undefined && bProp === undefined)
                            return 0;
                        if (typeof aProp === "string" && typeof bProp === "string")
                            return aProp?.localeCompare(bProp) * (sorting.direction === "asc" ? 1 : -1);
                        if (typeof aProp === "number" && typeof bProp === "number")
                            return (aProp - bProp) * (sorting.direction === "asc" ? 1 : -1);
                        if (aProp === undefined)
                            return sorting.direction === "asc" ? 1 : -1;
                        if (bProp === undefined)
                            return sorting.direction === "asc" ? -1 : 1;
                        return 0;
                    });
            }
        }), shareReplay(1));
        this.smallstackType$ = this.data$.pipe(map((tableConfiguration) => tableConfiguration?.typeName), filterNullish(), switchMap((typeName) => this.frontendTypeRegistry.getTypeByPath(typeName)), shareReplay(1));
        this.searchResult$ = combineLatest([
            this.tableData$,
            this.searchText$,
            this.smallstackType$,
            this.collection$,
            this.sorting$
        ]).pipe(map(([values, searchText, smallstackType, collection, sorting]) => {
            // remove selection
            this.selectedIds = [];
            // searching
            if (searchText) {
                let allProperties = [];
                if (smallstackType?.searchableFields instanceof Array && smallstackType.searchableFields.length > 0)
                    allProperties = smallstackType.searchableFields;
                else {
                    allProperties = getSchemaPropertiesKeys(collection.rxCollection.schema.jsonSchema).map((key) => {
                        return { name: key, weight: 10 };
                    });
                }
                const fuse = new Fuse(values.map((val) => val), {
                    keys: allProperties,
                    isCaseSensitive: false,
                    ignoreLocation: true,
                    includeScore: true,
                    shouldSort: sorting?.propertyName === this.SEARCH_RESULT_SCORE_SORT,
                    sortFn: (a, b) => {
                        if (sorting?.direction === "asc")
                            return a.score - b.score;
                        else
                            return b.score - a.score;
                    },
                    threshold: 0.3
                });
                const result = fuse.search(searchText).map((s) => ({
                    ...s.item,
                    score: when(s.score)
                        .is((s) => s < 0.0000001, () => "Sehr gut")
                        .is((s) => s < 0.0005, () => "Gut")
                        .is((s) => s < 0.005, () => "Mittel")
                        .is((s) => s < 0.1, () => "Ungenau")
                        .default(() => "Schlecht")
                }));
                return result;
            }
            this.isLoading$.next(false);
            return values;
        }), shareReplay(1));
        this.hasSearchResults$ = combineLatest([this.searchText$, this.filterSearch$]).pipe(map(([searchText, filterSearch]) => !!searchText || !isEmptyObject(filterSearch)));
        this.showFullTextSearch$ = this.data$.pipe(filterNullish(), map((data) => data?.showFullTextSearch ?? true));
        this.searchableFields$ = this.smallstackType$.pipe(map((type) => type?.searchableFields), map((searchableFields) => searchableFields?.map((sf) => sf.name) ?? []), map((searchableFields) => searchableFields.join(", ")));
        this.componentHeight$ = this.showFullTextSearch$.pipe(filterNullish(), map((showFullTextSearch) => {
            let totalExtraHeight = 0;
            if (showFullTextSearch)
                totalExtraHeight += FULL_TEXT_SEARCH_HEIGHT;
            return totalExtraHeight;
        }));
        // state
        this.isLoading$ = new BehaviorSubject(true);
        this.isEmpty$ = this.tableData$.pipe(startWith(undefined), map((data) => !data));
        this.isMobile$ = this.breakPointService.isMobile$;
        this.selectedIds = [];
        this.filterSchema$ = this.data$.pipe(filterNullish(), switchMap(async () => {
            const schema = await this.schemaService.getSchemaByName(this.data.typeName);
            return this.schemaService.evalRefSchema(schema);
        }), map((schema) => removeRequired(schema)));
        this.showCheckboxes$ = this.data$.pipe(filterNullish(), map((data) => data?.showCheckboxes ?? true));
        this.containerWidth$ = new BehaviorSubject("100%");
        // google maps related stuff
        this.convertGeoPointToLatLng = convertGeoPointToLatLng;
        this.googleMapsOverlayOpened = false;
        this.errors = [];
        this.mappingArray = {};
        this.WidgetTag = WidgetTag;
    }
    get headerOffset() {
        if (!this.viewPort || !this.viewPort["_renderedContentOffset"]) {
            return "-0px";
        }
        const offset = this.viewPort["_renderedContentOffset"];
        return `-${offset}px`;
    }
    get footerOffset() {
        if (!this.viewPort || !this.viewPort["_renderedContentOffset"]) {
            return "0px";
        }
        const offset = this.viewPort["_renderedContentOffset"];
        return `${offset}px`;
    }
    async sort(propertyName, direction) {
        // set user sorting
        const currentSort = await firstValueFrom(this.sorting$);
        if (currentSort?.propertyName === propertyName && currentSort?.direction === direction) {
            this.userSorting$.next(undefined);
            // sync with url
            await this.routerUtilService.removeSearchParameter("sort");
        }
        else {
            this.userSorting$.next({ propertyName, direction });
            // sync with url
            await this.routerUtilService.addSearchParameter("sort", convertToSortString(propertyName, direction));
        }
    }
    async removeSort() {
        this.userSorting$.next(undefined);
        await this.routerUtilService.removeSearchParameter("sort");
    }
    async toggleSort(propertyName, isSortable) {
        if (isSortable) {
            const currentSort = await firstValueFrom(this.sorting$);
            if (currentSort?.propertyName === propertyName) {
                if (currentSort.direction === "asc")
                    await this.sort(propertyName, "desc");
                else
                    await this.removeSort();
            }
            else
                await this.sort(propertyName, "asc");
        }
    }
    setInlineFilter(propertyName, element) {
        const value = getJsonByPath(element, propertyName);
        const current = this.filterSearch$.value;
        this.filterSearch$.next(setJsonProperty(current, propertyName, value));
        this.filterBarVisible$.next(true);
    }
    qrCodeDialog(value, prefix = "") {
        this.matDialog.closeAll();
        this.matDialog.open(QRCodeDialogComponent, { data: prefix + value, autoFocus: false });
    }
    async openDialog(lp, model) {
        this.matDialog.closeAll();
        if (lp.dialogUrlSyncParameter)
            await this.routerUtilService.addSearchParameter(lp.dialogUrlSyncParameter, model.id);
        void this.matDialog
            .open(DataTableV3DialogComponent, {
            width: lp.dialogWidth,
            height: lp.dialogHeight,
            autoFocus: false,
            data: {
                cmsComponent: lp.dialogComponent,
                widgetRendererOptions: {
                    editMode: this.editMode
                },
                context: model
            }
        })
            .afterClosed()
            .subscribe(async (component) => {
            if (this.editMode === true && component) {
                this.data.listProperties[lp.index].dialogComponent = component;
                this.dataChange.emit(this.data);
            }
            if (lp.dialogUrlSyncParameter)
                await this.routerUtilService.removeSearchParameter(lp.dialogUrlSyncParameter);
        });
    }
    openEditor(model) {
        return async () => {
            const data = await firstValueFrom(this.data$);
            const returnedModel = await this.frontendTypeRegistry.openEditor(data.typeName, model);
            if (returnedModel)
                await (await this.rxCollectionService.getCollection(data.typeName)).rxCollection.upsert(returnedModel);
        };
    }
    deleteData(elem) {
        return async () => {
            const answer = await this.notificationService.popup.confirmation("Datensatz löschen", "Soll der Datensatz wirklich gelöscht werden?", [
                { label: "@@actions.no", color: "primary", value: false },
                { label: "@@actions.yes", color: "error", value: true }
            ]);
            if (answer === true) {
                const data = await firstValueFrom(this.data$);
                const crud = this.frontendTypeRegistry.getCrud(data?.typeName);
                await crud.delete(elem.id);
                const collection = await this.rxCollectionService.getCollection(data?.typeName);
                await collection.rxCollection
                    .findOne(elem.id)
                    .exec()
                    .then((doc) => doc.remove());
            }
        };
    }
    deleteManyData(ids) {
        return async () => {
            const plural = ids.length !== 1;
            const answer = await this.notificationService.popup.confirmation(ids.length + " " + (plural ? "Datensätze" : "Datensatz") + " löschen", plural
                ? "Möchten Sie wirklich die " + ids.length + " selektierten Datensätze löschen?"
                : "Soll der Datensatz wirklich gelöscht werden?", [
                { label: "@@actions.no", classes: "btn btn-outline", value: false },
                { label: "@@actions.yes", classes: "btn btn-error", value: true }
            ]);
            if (answer === true) {
                const data = await firstValueFrom(this.data$);
                const crud = this.frontendTypeRegistry.getCrud(data?.typeName);
                await crud.deleteMany(ids);
                const collection = await this.rxCollectionService.getCollection(data?.typeName);
                for (const elem of ids)
                    await collection.rxCollection
                        .findOne(elem)
                        .exec()
                        .then((doc) => doc.remove());
                this.selectedIds = [];
            }
        };
    }
    exportData(selectedIds) {
        return async () => {
            const data = await firstValueFrom(this.searchResult$);
            const models = data.filter((d) => selectedIds.includes(d.id));
            const type = await firstValueFrom(this.smallstackType$);
            this.matDialog.open(WidgetDialogComponent, {
                width: "80vw",
                data: {
                    widget: {
                        name: "DataExportWidget",
                        data: {
                            models,
                            type,
                            schema: await this.schemaService.getSchemaByName(type.path)
                        }
                    }
                }
            });
        };
    }
    async toggleAll(checkboxEvent) {
        const target = checkboxEvent.target;
        if (target.checked) {
            const currentData = await firstValueFrom(this.searchResult$);
            this.selectedIds = currentData.map((data) => data.id);
        }
        else
            this.selectedIds = [];
    }
    async toggleEntry(id, checkboxEvent) {
        const target = checkboxEvent.target;
        if (target.checked)
            this.selectedIds = onlyUnique([...this.selectedIds, id]);
        else
            this.selectedIds = this.selectedIds.filter((selectedId) => selectedId !== id);
    }
    /** callback fn for when a widget got set */
    async setWidgetListProperty(propertyName, newWidget) {
        const data = await firstValueFrom(this.data$);
        const index = data.listProperties?.findIndex((lp) => lp.property === propertyName);
        if (index === -1)
            throw new Error("Could not find list property by propertyName: " + propertyName);
        data.listProperties[index].widget = newWidget;
        this.dataChange.emit(data);
    }
    reload(forceCompleteReload) {
        return async () => {
            const collection = await firstValueFrom(this.collection$);
            if (forceCompleteReload)
                await collection.cleanAndResync();
            else
                await collection.sync();
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: DataTableV3WidgetComponent, deps: [{ token: i1.MatDialog }, { token: i2.NotificationService }, { token: i3.RouterUtilService }, { token: i1$1.FrontendTypeRegistry }, { token: i3.BreakpointService }, { token: i1$1.RxCollectionService }, { token: i3.FrontendSchemaService }, { token: i5.ActivatedRoute }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: DataTableV3WidgetComponent, isStandalone: true, selector: "smallstack-data-table-v3-widget", host: { properties: { "style.height": "this.height" } }, viewQueries: [{ propertyName: "viewPort", first: true, predicate: CdkVirtualScrollViewport, descendants: true }], usesInheritance: true, ngImport: i0, template: "<div style=\"min-height: 200px\" class=\"h-full p-2\">\n  <div *rxIf=\"showFullTextSearch$\" class=\"form-control pb-2\">\n    <div class=\"input-group\">\n      <input\n        #input\n        type=\"text\"\n        placeholder=\"Volltext Suche\"\n        class=\"input input-bordered w-full shadow-sm\"\n        (keyup)=\"searchTextInput$.next($any($event.target).value)\"\n        (focus)=\"sendSocketData('focused')\"\n        [ngModel]=\"searchTextInput$.value\"\n        data-testid=\"full-text-search\"\n      />\n      <button\n        *ngIf=\"searchTextInput$.value\"\n        class=\"btn btn-square btn-warning shadow-sm border-r border-r-gray-300\"\n        (click)=\"searchTextInput$.next(undefined)\"\n      >\n        <smallstack-icon\n          name=\"trash\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.warning.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </button>\n      <button class=\"btn btn-square btn-primary shadow-sm\" (click)=\"searchTextInput$.next(input.value)\">\n        <span *rxIf=\"isLoading$; else icon\" class=\"loading loading-spinner\"></span>\n        <ng-template #icon>\n          <smallstack-icon\n            name=\"search\"\n            theme=\"fluency-systems-regular\"\n            themeColor=\"daisyTheme.primary.textColor\"\n            size=\"md\"\n          ></smallstack-icon>\n        </ng-template>\n      </button>\n      <button\n        class=\"btn btn-square btn-primary shadow-sm border-l border-l-gray-300\"\n        (click)=\"filterBarVisible$.next(!filterBarVisible$.value)\"\n      >\n        <smallstack-icon\n          name=\"filter\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.primary.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </button>\n    </div>\n  </div>\n\n  <ng-container *ngIf=\"errors?.length > 0\">\n    <div *ngFor=\"let error of errors\">\n      {{ error }}\n    </div>\n  </ng-container>\n  <ng-container *rxLet=\"searchResult$; let tableData\">\n    <ng-container *rxLet=\"data$; let tableConfiguration\">\n      <smallstack-loader *rxIf=\"isLoading$; else showTable\"></smallstack-loader>\n\n      <ng-template #showTable>\n        <ng-container\n          *ngIf=\"tableConfiguration && tableConfiguration.listProperties?.length > 0; else widgetNotConfigured\"\n        >\n          <div\n            class=\"border rounded shadow\"\n            style=\"height: calc(100% - {{ componentHeight$ | push }}px);min-height: 300px\"\n          >\n            <div class=\"scrolling-table h-full\">\n              <cdk-virtual-scroll-viewport [itemSize]=\"64\" class=\"h-full\" style=\"min-height: 300px\">\n                <table class=\"table\">\n                  <thead\n                    smallstack-form\n                    [schema]=\"filterSchema$ | push\"\n                    [value]=\"filterSearch$ | push\"\n                    [options]=\"{ compactMode: true, showLabel: false, showHint: false }\"\n                    (valueChange)=\"filterSearch$.next($event)\"\n                    [style.top]=\"headerOffset\"\n                  >\n                    <ng-container *rxLet=\"sorting$; let sorting\">\n                      <tr>\n                        <th *rxIf=\"showCheckboxes$\" class=\"w-10 center-center\">\n                          <input\n                            type=\"checkbox\"\n                            class=\"checkbox checkbox-primary checkbox-sm\"\n                            [indeterminate]=\"selectedIds.length !== tableData?.length && selectedIds.length !== 0\"\n                            [checked]=\"selectedIds.length === tableData.length && selectedIds.length !== 0\"\n                            (change)=\"toggleAll($event)\"\n                            data-test=\"check-all\"\n                          />\n                        </th>\n                        <th\n                          *rxIf=\"searchTextInput$\"\n                          (click)=\"toggleSort(SEARCH_RESULT_SCORE_SORT, true)\"\n                          [resizeColumn]=\"true\"\n                        >\n                          <div class=\"flex flex-row justify-between items-center overflow-hidden\">\n                            <span>Such Relevanz</span>\n                            <smallstack-sort-icon\n                              [sorting]=\"sorting\"\n                              [defaultSorting]=\"defaultSorting$ | push\"\n                              [propertyName]=\"SEARCH_RESULT_SCORE_SORT\"\n                            ></smallstack-sort-icon>\n                          </div>\n                        </th>\n                        <th *rxFor=\"let listProperty of tableConfiguration.listProperties\" [resizeColumn]=\"true\">\n                          <div class=\"w-full flex flex-row justify-between items-center overflow-hidden\">\n                            <div class=\"flex-shrink overflow-hidden flex flex-row items-center\">\n                              <smallstack-i18n\n                                (click)=\"toggleSort(listProperty.property, listProperty.sortable)\"\n                                [data]=\"listProperty.title\"\n                                class=\"select-none overflow-hidden text-ellipsis\"\n                                [ngClass]=\"{ 'cursor-pointer': listProperty.sortable }\"\n                              ></smallstack-i18n>\n                              <smallstack-sort-icon\n                                [sorting]=\"sorting\"\n                                [defaultSorting]=\"defaultSorting$ | push\"\n                                [propertyName]=\"listProperty.property\"\n                              ></smallstack-sort-icon>\n                            </div>\n                            <div *rxIf=\"listProperty.sortable\" class=\"w-4 h-4\" tabindex=\"0\">\n                              <smallstack-icon\n                                (click)=\"menu.openOverlay()\"\n                                name=\"menu-2\"\n                                size=\"16\"\n                                theme=\"fluency-systems-regular\"\n                                class=\"cursor-pointer opacity-50 hover:opacity-100\"\n                              ></smallstack-icon>\n                              <smallstack-overlay #menu>\n                                <div class=\"input-dropdown flex flex-col gap-2 justify-start items-start p-2\">\n                                  <ng-container>\n                                    <button\n                                      (click)=\"sort(listProperty.property, 'asc')\"\n                                      class=\"btn btn-xs btn-block\"\n                                      closeDropDownOnClick\n                                    >\n                                      Aufsteigend sortieren\n                                    </button>\n                                    <button\n                                      (click)=\"sort(listProperty.property, 'desc')\"\n                                      class=\"btn btn-xs btn-block\"\n                                      closeDropDownOnClick\n                                    >\n                                      Absteigend sortieren\n                                    </button>\n                                  </ng-container>\n                                </div>\n                              </smallstack-overlay>\n                            </div>\n                          </div>\n                        </th>\n                        <th [resizeColumn]=\"true\">Actions</th>\n                      </tr>\n                    </ng-container>\n                    <tr class=\"rx-table-filter-row\" [ngClass]=\"{ hidden: !(filterBarVisible$ | push) }\">\n                      <!-- Filter Bar -->\n                      <th *rxIf=\"showCheckboxes$\" class=\"w-10\"></th>\n                      <th *rxIf=\"searchTextInput$\"></th>\n                      <th *rxFor=\"let lp of tableConfiguration.listProperties\">\n                        <smallstack-widget-tree\n                          *ngIf=\"lp.filterable !== false\"\n                          [widget]=\"{\n                            name: 'FilterField',\n                            data: { path: lp.property, filterSchema: lp.filterSchemaOverride }\n                          }\"\n                        ></smallstack-widget-tree>\n                      </th>\n                      <th>\n                        <button class=\"btn btn-warning btn-sm\" (click)=\"filterSearch$.next(undefined)\">l\u00F6schen</button>\n                      </th>\n                    </tr>\n                  </thead>\n                  <tbody>\n                    <tr *ngIf=\"tableData === undefined || tableData === null || tableData.length === 0\">\n                      <td colspan=\"100%\" class=\"text-center text-help m-10\">\n                        {{ (hasSearchResults$ | push) ? \"Keine Suchergebnisse\" : \"Keine Daten vorhanden\" }}\n                      </td>\n                    </tr>\n                    <!-- DATA ROWS -->\n                    <tr\n                      *cdkVirtualFor=\"let element of searchResult$; let index = index; ngForTrackById\"\n                      class=\"h-16\"\n                      data-test=\"table-row\"\n                      #rxTableRow\n                    >\n                      <td *rxIf=\"showCheckboxes$\" class=\"w-10\">\n                        <input\n                          type=\"checkbox\"\n                          class=\"checkbox checkbox-primary checkbox-sm\"\n                          [checked]=\"selectedIds.includes(element.id)\"\n                          (change)=\"toggleEntry(element.id, $event)\"\n                          attr.data-testid=\"checkbox-{{ index }}\"\n                        />\n                      </td>\n                      <td *rxIf=\"searchTextInput$\" class=\"text-center\">\n                        <span class=\"text-help\">{{ element.score }}</span>\n                      </td>\n                      <td *rxFor=\"let lp of tableConfiguration.listProperties\" [ngStyle]=\"{ flex: lp.width || 10 }\">\n                        <div *ngIf=\"lp.filterable\" class=\"absolute right-0 inline-filter invisible\">\n                          <smallstack-icon\n                            (click)=\"setInlineFilter(lp.property, element)\"\n                            name=\"filter\"\n                            class=\"opacity-60 cursor-pointer\"\n                          ></smallstack-icon>\n                        </div>\n                        <div class=\"font-bold mb-1 md:hidden\">\n                          <smallstack-i18n [data]=\"lp.title\"></smallstack-i18n>\n                        </div>\n                        <ng-container [ngSwitch]=\"lp.renderer\">\n                          <ng-container *ngSwitchCase=\"'date'\">\n                            <smallstack-date\n                              [format]=\"lp.rendererDateFormat\"\n                              [timestamp]=\"element | jsonByPath: lp.property\"\n                              style=\"white-space: nowrap\"\n                            ></smallstack-date>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'duration'\">\n                            <smallstack-duration [duration]=\"element | jsonByPath: lp.property\"></smallstack-duration>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'icon'\">\n                            <smallstack-icon\n                              size=\"24\"\n                              [alias]=\"\n                                mappingArray[lp.property][element[lp.property]]\n                                  ? mappingArray[lp.property][element[lp.property]]\n                                  : lp.defaultIcon\n                              \"\n                            ></smallstack-icon>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'image'\">\n                            <smallstack-overlay #overlay>\n                              <div class=\"card card-bordered card-compact shadow-xl bg-white\">\n                                <div class=\"card-body\">\n                                  <img [src]=\"element | jsonByPath: lp.property\" class=\"w-100\" />\n                                </div>\n                              </div>\n                            </smallstack-overlay>\n                            <img\n                              class=\"mask mask-square w-16 cursor-pointer\"\n                              [src]=\"element | jsonByPath: lp.property\"\n                              (click)=\"overlay.openOverlay()\"\n                            />\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'storeProperty'\">\n                            <smallstack-store-property\n                              [storeName]=\"lp.rendererStorePropertyStore\"\n                              [property]=\"lp.rendererStorePropertyProperty\"\n                              [modelId]=\"element | flatten: lp.property\"\n                            >\n                            </smallstack-store-property>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'i18n'\">\n                            <ng-container *ngIf=\"lp.i18nPrefix; else unPrefixed\">\n                              <smallstack-i18n\n                                [data]=\"(lp.i18nPrefix ? lp.i18nPrefix : '') + element | jsonByPath: lp.property\"\n                              ></smallstack-i18n>\n                            </ng-container>\n                            <ng-template #unPrefixed>\n                              <smallstack-i18n [data]=\"element | jsonByPath: lp.property\"></smallstack-i18n>\n                            </ng-template>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'qrCode'\">\n                            <button class=\"btn-action\" (click)=\"qrCodeDialog(element[lp.property], lp.qrCodePrefix)\">\n                              <smallstack-icon alias=\"qrcode\"></smallstack-icon>\n                            </button>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'dialog'\">\n                            <button class=\"btn-action\" (click)=\"openDialog(lp, element)\">\n                              <smallstack-icon [name]=\"lp.dialogButtonIcon\"></smallstack-icon>\n                            </button>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'link'\">\n                            <a\n                              href=\"{{ element | jsonByPath: lp.property }}\"\n                              target=\"{{ lp.openLinkInNewWindow ? '_blank' : undefined }}\"\n                            >\n                              <ng-container *ngIf=\"lp.linkLabel; else noLabel\">\n                                {{ lp.linkLabel }}\n                              </ng-container>\n                              <ng-template #noLabel>\n                                {{ element | jsonByPath: lp.property }}\n                              </ng-template>\n                            </a>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'boolean'\">\n                            <smallstack-icon\n                              name=\"checkmark--v1\"\n                              theme=\"color\"\n                              size=\"24\"\n                              *ngIf=\"(element | jsonByPath: lp.property) === true; else falsy\"\n                            >\n                            </smallstack-icon>\n                            <ng-template #falsy>\n                              <smallstack-icon name=\"delete-sign--v1\" theme=\"color\" size=\"24\"> </smallstack-icon>\n                            </ng-template>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'markdown'\">\n                            <smallstack-markdown-viewer\n                              [text]=\"element | jsonByPath: lp.property\"\n                            ></smallstack-markdown-viewer>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'googleMap'\">\n                            <div style=\"cursor: pointer; position: relative\" (click)=\"overlay.openOverlay()\">\n                              <div style=\"position: absolute; width: 100%; height: 100%; z-index: 100\"></div>\n                              <google-map\n                                [width]=\"lp.googleMapsPreviewWidth\"\n                                [height]=\"lp.googleMapsPreviewHeight\"\n                                [zoom]=\"14\"\n                                [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                [options]=\"{\n                                  gestureHandling: 'none',\n                                  disableDefaultUI: true,\n                                  styles: [\n                                    {\n                                      featureType: 'poi',\n                                      elementType: 'labels',\n                                      stylers: [{ visibility: 'off' }]\n                                    }\n                                  ]\n                                }\"\n                              >\n                                <map-marker\n                                  [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                  [clickable]=\"false\"\n                                ></map-marker>\n                              </google-map>\n                            </div>\n                            <smallstack-overlay #overlay>\n                              <mat-card appearance=\"outlined\" class=\"flex flex-col space-y-5\">\n                                <google-map\n                                  width=\"350px\"\n                                  height=\"350px\"\n                                  [zoom]=\"16\"\n                                  [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                >\n                                  <map-marker\n                                    [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                    [clickable]=\"false\"\n                                  ></map-marker>\n                                </google-map>\n                                <button class=\"btn btn-primary\" (click)=\"overlay.closeOverlay()\">\n                                  <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n                                </button>\n                              </mat-card>\n                            </smallstack-overlay>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'widget'\">\n                            <ng-container *ngIf=\"lp.widget\">\n                              <smallstack-widget-tree\n                                *ngIf=\"lp.widgetContextType === 'full'; else propertyContext\"\n                                [widget]=\"lp.widget\"\n                                (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                                [widgetRendererOptions]=\"{\n                                  editMode$: widgetTreeService.editMode$\n                                }\"\n                                [context]=\"{ model: element }\"\n                                [globals]=\"{ model: element }\"\n                              ></smallstack-widget-tree>\n                              <ng-template #propertyContext>\n                                <smallstack-widget-tree\n                                  [widget]=\"lp.widget\"\n                                  (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                                  [widgetRendererOptions]=\"{\n                                    editMode$: widgetTreeService.editMode$\n                                  }\"\n                                  [context]=\"{ model: element | jsonByPath: lp.property }\"\n                                  [globals]=\"{ model: element }\"\n                                ></smallstack-widget-tree\n                              ></ng-template>\n                            </ng-container>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'currency'\">\n                            <smallstack-currency\n                              [iso]=\"lp.currency ? lp.currency : 'EUR'\"\n                              [cents]=\"element[lp.property]\"\n                            ></smallstack-currency>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'valueMapping'\">\n                            <span>{{\n                              lp.mappingArray\n                                | objectArrayValue: \"value\":element[lp.property]:\"mappedValue\":lp.defaultValue\n                            }}</span>\n                          </ng-container>\n                          <ng-container *ngSwitchDefault>\n                            {{ element | flatten: lp.property | jsonstring }}\n                          </ng-container>\n                        </ng-container>\n                      </td>\n\n                      <td class=\"flex flex-row justify-start items-center\">\n                        <ng-container *ngIf=\"data?.showDeleteButton\">\n                          <button\n                            class=\"btn-action btn-error\"\n                            [loadingFn]=\"deleteData(element)\"\n                            *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                            data-test=\"delete-entry\"\n                          >\n                            <smallstack-icon alias=\"delete\"></smallstack-icon>\n                          </button>\n                        </ng-container>\n                        <ng-container *ngIf=\"data?.showEditButton\">\n                          <button\n                            class=\"btn-action btn-primary\"\n                            [loadingFn]=\"openEditor(element)\"\n                            *showForPermission=\"(smallstackType$ | push)?.permissions?.update\"\n                            data-test=\"edit-entry\"\n                          >\n                            <smallstack-icon alias=\"edit\"></smallstack-icon>\n                          </button>\n                        </ng-container>\n                        <smallstack-widget-child\n                          [(data)]=\"data\"\n                          property=\"actionWidget\"\n                          [context]=\"{ model: element }\"\n                          (dataChange)=\"dataChange.emit($event)\"\n                        ></smallstack-widget-child>\n                      </td>\n                    </tr>\n                  </tbody>\n                  <tfoot [style.bottom]=\"footerOffset\">\n                    <tr>\n                      <td colspan=\"100%\">\n                        <div class=\"flex flex-row justify-between items-center w-full px-2 rx-table-actions\">\n                          <!-- selected id actions -->\n                          <div *rxIf=\"showCheckboxes$\" class=\"flex flex-row justify-start relative\">\n                            <!-- hide if no items are selected -->\n                            <div\n                              *rxIf=\"selectedIds.length === 0\"\n                              class=\"absolute w-full h-full top-0 left-0 z-50 bg-slate-100 opacity-80 cursor-not-allowed\"\n                            ></div>\n                            <div *ngIf=\"data.allowMultiDelete\" class=\"flex flex-row justify-start items-center gap-2\">\n                              <button\n                                class=\"btn btn-error flex flex-row gap-1 items-center text-white\"\n                                [loadingFn]=\"deleteManyData(selectedIds)\"\n                                matTooltip=\"Markierte Datens\u00E4tze l\u00F6schen\"\n                                *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                              >\n                                <smallstack-icon\n                                  alias=\"delete\"\n                                  theme=\"fluency-systems-regular\"\n                                  themeColor=\"daisyTheme.primary.textColor\"\n                                ></smallstack-icon>\n                                <smallstack-i18n data=\"@@actions.delete\"></smallstack-i18n>\n                              </button>\n                              <ng-container *rxIf=\"data.showExportButton !== false\">\n                                <button\n                                  class=\"btn btn-primary flex flex-row gap-1 items-center text-white\"\n                                  [loadingFn]=\"exportData(selectedIds)\"\n                                  matTooltip=\"Markierte Datens\u00E4tze exportieren\"\n                                  *showForPermission=\"(smallstackType$ | push)?.permissions?.readAll\"\n                                >\n                                  <smallstack-icon\n                                    name=\"export\"\n                                    theme=\"fluency-systems-regular\"\n                                    themeColor=\"daisyTheme.primary.textColor\"\n                                  ></smallstack-icon>\n                                  <smallstack-i18n data=\"@@actions.export\"></smallstack-i18n>\n                                </button>\n                              </ng-container>\n                            </div>\n                            <smallstack-widget-child\n                              property=\"listActionsComponent\"\n                              [(data)]=\"data\"\n                              [context]=\"{selectedIds}\"\n                              [widgetTags]=\"[WidgetTag.ICON, WidgetTag.CONTAINER]\"\n                              (dataChange)=\"dataChange.emit($event)\"\n                            ></smallstack-widget-child>\n                          </div>\n                          <!-- information -->\n                          <div class=\"justify-center items-center text-help\" *rxLet=\"totalCount$; let totalCount\">\n                            {{ totalCount }} Datens\u00E4tze insgesamt<span\n                              *rxIf=\"totalCount !== tableData.length || hasSearchResults$ || filterSearch$\"\n                            >\n                              | {{ tableData.length }} Suchergebnisse</span\n                            ><span *ngIf=\"selectedIds?.length > 0\"> | {{ selectedIds.length }} markiert</span></div\n                          >\n                          <div class=\"flex flex-row gap-2\">\n                            <button\n                              class=\"btn btn-primary flex flex-row gap-1 items-center\"\n                              [loadingFn]=\"reload(false)\"\n                              (longPress)=\"reload(true)()\"\n                              data-test=\"reload\"\n                            >\n                              <smallstack-icon\n                                alias=\"refresh\"\n                                theme=\"fluency-systems-regular\"\n                                themeColor=\"daisyTheme.primary.textColor\"\n                              ></smallstack-icon>\n                              <smallstack-i18n data=\"@@actions.reload\"></smallstack-i18n>\n                            </button>\n                            <ng-container *showForPermission=\"(smallstackType$ | push)?.permissions?.create\">\n                              <button\n                                *ngIf=\"tableConfiguration?.showCreateButton !== false\"\n                                class=\"btn btn-primary flex flex-row gap-1 items-center\"\n                                [loadingFn]=\"openEditor()\"\n                                data-test=\"create\"\n                              >\n                                <smallstack-icon\n                                  alias=\"plus\"\n                                  theme=\"fluency-systems-regular\"\n                                  themeColor=\"daisyTheme.primary.textColor\"\n                                ></smallstack-icon>\n                                <smallstack-i18n data=\"@@actions.create\"></smallstack-i18n>\n                              </button>\n                            </ng-container>\n                          </div>\n                        </div>\n                      </td>\n                    </tr>\n                  </tfoot>\n                </table>\n              </cdk-virtual-scroll-viewport>\n            </div>\n          </div>\n        </ng-container>\n      </ng-template>\n    </ng-container>\n  </ng-container>\n  <ng-template #widgetNotConfigured>\n    <div style=\"height: 60px\" class=\"flex flex-col justify-center items-center\">\n      <i><smallstack-i18n data=\"@@widgets.dataTable.errors.notConfiguredYet\"></smallstack-i18n></i>\n    </div>\n  </ng-template>\n</div>\n", styles: ["table{border-collapse:separate;border-spacing:0}th{@apply p-1 overflow-hidden border-r border-r-white bg-slate-100 h-10 sticky text-sm;}thead{@apply sticky top-0 z-50;}thead tr{@apply bg-white;}thead tr th{@apply border-b border-b-white;}tfoot{@apply sticky bottom-0 z-50 bg-slate-100;}tfoot tr{@apply bg-white;}tfoot tr td{@apply border-t border-t-white bg-slate-100;}tbody tr{@apply bg-white;}tbody tr:nth-child(odd){@apply bg-slate-50;}tbody tr:hover{@apply bg-slate-100;}td{@apply overflow-hidden p-2 h-16;}.rx-table-filter-row ::ng-deep .input{@apply input-sm font-light;}.rx-table-filter-row ::ng-deep .btn{@apply btn-sm;}.rx-table-filter-row ::ng-deep .menu{@apply menu-xs;}.rx-table-actions ::ng-deep .btn{@apply btn-sm;}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i6.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i6.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i6.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i6.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i6.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i6.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: CurrencyComponent, selector: "smallstack-currency", inputs: ["iso", "value", "euros", "cents"] }, { kind: "component", type: DateComponent, selector: "smallstack-date", inputs: ["timestamp", "format"] }, { kind: "component", type: DurationComponent, selector: "smallstack-duration", inputs: ["start", "end", "duration"] }, { kind: "pipe", type: FlattenPipe, name: "flatten" }, { kind: "ngmodule", type: GoogleMapsModule }, { kind: "component", type: i7.GoogleMap, selector: "google-map", inputs: ["height", "width", "mapTypeId", "center", "zoom", "options"], outputs: ["mapInitialized", "authFailure", "boundsChanged", "centerChanged", "mapClick", "mapDblclick", "mapDrag", "mapDragend", "mapDragstart", "headingChanged", "idle", "maptypeidChanged", "mapMousemove", "mapMouseout", "mapMouseover", "projectionChanged", "mapRightclick", "tilesloaded", "tiltChanged", "zoomChanged"], exportAs: ["googleMap"] }, { kind: "directive", type: i7.MapMarker, selector: "map-marker", inputs: ["title", "position", "label", "clickable", "options", "icon", "visible"], outputs: ["animationChanged", "mapClick", "clickableChanged", "cursorChanged", "mapDblclick", "mapDrag", "mapDragend", "draggableChanged", "mapDragstart", "flatChanged", "iconChanged", "mapMousedown", "mapMouseout", "mapMouseover", "mapMouseup", "positionChanged", "mapRightclick", "shapeChanged", "titleChanged", "visibleChanged", "zindexChanged"], exportAs: ["mapMarker"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "pipe", type: JsonByPathPipe, name: "jsonByPath" }, { kind: "pipe", type: JsonStringPipe, name: "jsonstring" }, { kind: "component", type: LoaderComponent, selector: "smallstack-loader", inputs: ["loading", "color", "size", "loadingText"] }, { kind: "directive", type: LoadingElementDirective, selector: "[loadingFn]", inputs: ["loadingFn", "isLoading"], exportAs: ["loadingFn"] }, { kind: "component", type: MarkdownViewerComponent, selector: "smallstack-markdown-viewer", inputs: ["text"] }, { kind: "ngmodule", type: MatCardModule }, { kind: "component", type: i8.MatCard, selector: "mat-card", inputs: ["appearance"], exportAs: ["matCard"] }, { kind: "ngmodule", type: MatTableModule }, { kind: "ngmodule", type: MatSortModule }, { kind: "pipe", type: ObjectArrayValuePipe, name: "objectArrayValue" }, { kind: "component", type: OverlayComponent, selector: "smallstack-overlay", inputs: ["hasBackdrop"] }, { kind: "component", type: StorePropertyComponent, selector: "smallstack-store-property", inputs: ["store", "storeName", "modelId", "property", "notFound", "showNotFound"] }, { kind: "component", type: WidgetChildComponent, selector: "smallstack-widget-child", inputs: ["data", "context", "property", "widgetTags"], outputs: ["dataChange"] }, { kind: "component", type: WidgetTreeComponent, selector: "smallstack-widget-tree", inputs: ["widgetRendererOptions", "widget", "context", "globals", "connections", "rootSockets"], outputs: ["connectionsChange", "widgetChange"] }, { kind: "directive", type: ShowForPermissionDirective, selector: "[showForPermission]", inputs: ["showForPermission", "showForPermissionTenantId"] }, { kind: "ngmodule", type: ScrollingModule }, { kind: "directive", type: i10.CdkFixedSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "minBufferPx", "maxBufferPx"] }, { kind: "directive", type: i10.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { kind: "component", type: i10.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }, { kind: "pipe", type: RxPush, name: "push" }, { kind: "directive", type: RxFor, selector: "[rxFor][rxForOf]", inputs: ["rxForOf", "rxForTemplate", "rxForStrategy", "rxForParent", "rxForPatchZone", "rxForTrackBy", "rxForRenderCallback"] }, { kind: "directive", type: RxLet, selector: "[rxLet]", inputs: ["rxLet", "rxLetStrategy", "rxLetComplete", "rxLetError", "rxLetSuspense", "rxLetContextTrigger", "rxLetCompleteTrigger", "rxLetErrorTrigger", "rxLetSuspenseTrigger", "rxLetNextTrigger", "rxLetRenderCallback", "rxLetParent", "rxLetPatchZone"], outputs: ["rendered"] }, { kind: "directive", type: RxIf, selector: "[rxIf]", inputs: ["rxIf", "rxIfStrategy", "rxIfElse", "rxIfThen", "rxIfSuspense", "rxIfComplete", "rxIfError", "rxIfContextTrigger", "rxIfNextTrigger", "rxIfSuspenseTrigger", "rxIfErrorTrigger", "rxIfCompleteTrigger", "rxIfParent", "rxIfPatchZone", "rxIfRenderCallback"] }, { kind: "directive", type: LongPressDirective, selector: "[longPress]", inputs: ["duration"], outputs: ["longPress"] }, { kind: "directive", type: CloseDropDownOnClickDirective, selector: "[closeDropDownOnClick]" }, { kind: "directive", type: ResizeColumnDirective, selector: "[resizeColumn]", inputs: ["resizeColumn", "index"] }, { kind: "component", type: SortIconComponent, selector: "smallstack-sort-icon", inputs: ["propertyName", "sorting", "defaultSorting"] }, { kind: "component", type: FormComponent, selector: "smallstack-form,[smallstack-form]", inputs: ["schema", "options", "value"], outputs: ["valueChange", "submitForm"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: DataTableV3WidgetComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-data-table-v3-widget", changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        CurrencyComponent,
                        DateComponent,
                        DurationComponent,
                        FlattenPipe,
                        GoogleMapsModule,
                        I18nComponent,
                        IconComponent,
                        JsonByPathPipe,
                        JsonStringPipe,
                        ListContainerComponent,
                        LoaderComponent,
                        LoadingElementDirective,
                        MarkdownViewerComponent,
                        MatCardModule,
                        MatTableModule,
                        MatSortModule,
                        MatSortStoreDirective,
                        ObjectArrayValuePipe,
                        OverlayComponent,
                        StorePropertyComponent,
                        UppercaseSpacePipe,
                        WidgetChildComponent,
                        WidgetTreeComponent,
                        ShowForPermissionDirective,
                        LetDirective,
                        MatSortModule,
                        NgForTrackByIdDirective,
                        ScrollingModule,
                        RenderInViewportDirective,
                        RxPush,
                        RxFor,
                        RxLet,
                        RxIf,
                        DebugComponentComponent,
                        FixedSizeVirtualScrollStrategy,
                        RxVirtualScrollViewportComponent,
                        RxVirtualFor,
                        ScrollableDirective,
                        LongPressDirective,
                        CloseDropDownOnClickDirective,
                        ResizeColumnDirective,
                        SortIconComponent,
                        FormComponent
                    ], template: "<div style=\"min-height: 200px\" class=\"h-full p-2\">\n  <div *rxIf=\"showFullTextSearch$\" class=\"form-control pb-2\">\n    <div class=\"input-group\">\n      <input\n        #input\n        type=\"text\"\n        placeholder=\"Volltext Suche\"\n        class=\"input input-bordered w-full shadow-sm\"\n        (keyup)=\"searchTextInput$.next($any($event.target).value)\"\n        (focus)=\"sendSocketData('focused')\"\n        [ngModel]=\"searchTextInput$.value\"\n        data-testid=\"full-text-search\"\n      />\n      <button\n        *ngIf=\"searchTextInput$.value\"\n        class=\"btn btn-square btn-warning shadow-sm border-r border-r-gray-300\"\n        (click)=\"searchTextInput$.next(undefined)\"\n      >\n        <smallstack-icon\n          name=\"trash\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.warning.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </button>\n      <button class=\"btn btn-square btn-primary shadow-sm\" (click)=\"searchTextInput$.next(input.value)\">\n        <span *rxIf=\"isLoading$; else icon\" class=\"loading loading-spinner\"></span>\n        <ng-template #icon>\n          <smallstack-icon\n            name=\"search\"\n            theme=\"fluency-systems-regular\"\n            themeColor=\"daisyTheme.primary.textColor\"\n            size=\"md\"\n          ></smallstack-icon>\n        </ng-template>\n      </button>\n      <button\n        class=\"btn btn-square btn-primary shadow-sm border-l border-l-gray-300\"\n        (click)=\"filterBarVisible$.next(!filterBarVisible$.value)\"\n      >\n        <smallstack-icon\n          name=\"filter\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.primary.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </button>\n    </div>\n  </div>\n\n  <ng-container *ngIf=\"errors?.length > 0\">\n    <div *ngFor=\"let error of errors\">\n      {{ error }}\n    </div>\n  </ng-container>\n  <ng-container *rxLet=\"searchResult$; let tableData\">\n    <ng-container *rxLet=\"data$; let tableConfiguration\">\n      <smallstack-loader *rxIf=\"isLoading$; else showTable\"></smallstack-loader>\n\n      <ng-template #showTable>\n        <ng-container\n          *ngIf=\"tableConfiguration && tableConfiguration.listProperties?.length > 0; else widgetNotConfigured\"\n        >\n          <div\n            class=\"border rounded shadow\"\n            style=\"height: calc(100% - {{ componentHeight$ | push }}px);min-height: 300px\"\n          >\n            <div class=\"scrolling-table h-full\">\n              <cdk-virtual-scroll-viewport [itemSize]=\"64\" class=\"h-full\" style=\"min-height: 300px\">\n                <table class=\"table\">\n                  <thead\n                    smallstack-form\n                    [schema]=\"filterSchema$ | push\"\n                    [value]=\"filterSearch$ | push\"\n                    [options]=\"{ compactMode: true, showLabel: false, showHint: false }\"\n                    (valueChange)=\"filterSearch$.next($event)\"\n                    [style.top]=\"headerOffset\"\n                  >\n                    <ng-container *rxLet=\"sorting$; let sorting\">\n                      <tr>\n                        <th *rxIf=\"showCheckboxes$\" class=\"w-10 center-center\">\n                          <input\n                            type=\"checkbox\"\n                            class=\"checkbox checkbox-primary checkbox-sm\"\n                            [indeterminate]=\"selectedIds.length !== tableData?.length && selectedIds.length !== 0\"\n                            [checked]=\"selectedIds.length === tableData.length && selectedIds.length !== 0\"\n                            (change)=\"toggleAll($event)\"\n                            data-test=\"check-all\"\n                          />\n                        </th>\n                        <th\n                          *rxIf=\"searchTextInput$\"\n                          (click)=\"toggleSort(SEARCH_RESULT_SCORE_SORT, true)\"\n                          [resizeColumn]=\"true\"\n                        >\n                          <div class=\"flex flex-row justify-between items-center overflow-hidden\">\n                            <span>Such Relevanz</span>\n                            <smallstack-sort-icon\n                              [sorting]=\"sorting\"\n                              [defaultSorting]=\"defaultSorting$ | push\"\n                              [propertyName]=\"SEARCH_RESULT_SCORE_SORT\"\n                            ></smallstack-sort-icon>\n                          </div>\n                        </th>\n                        <th *rxFor=\"let listProperty of tableConfiguration.listProperties\" [resizeColumn]=\"true\">\n                          <div class=\"w-full flex flex-row justify-between items-center overflow-hidden\">\n                            <div class=\"flex-shrink overflow-hidden flex flex-row items-center\">\n                              <smallstack-i18n\n                                (click)=\"toggleSort(listProperty.property, listProperty.sortable)\"\n                                [data]=\"listProperty.title\"\n                                class=\"select-none overflow-hidden text-ellipsis\"\n                                [ngClass]=\"{ 'cursor-pointer': listProperty.sortable }\"\n                              ></smallstack-i18n>\n                              <smallstack-sort-icon\n                                [sorting]=\"sorting\"\n                                [defaultSorting]=\"defaultSorting$ | push\"\n                                [propertyName]=\"listProperty.property\"\n                              ></smallstack-sort-icon>\n                            </div>\n                            <div *rxIf=\"listProperty.sortable\" class=\"w-4 h-4\" tabindex=\"0\">\n                              <smallstack-icon\n                                (click)=\"menu.openOverlay()\"\n                                name=\"menu-2\"\n                                size=\"16\"\n                                theme=\"fluency-systems-regular\"\n                                class=\"cursor-pointer opacity-50 hover:opacity-100\"\n                              ></smallstack-icon>\n                              <smallstack-overlay #menu>\n                                <div class=\"input-dropdown flex flex-col gap-2 justify-start items-start p-2\">\n                                  <ng-container>\n                                    <button\n                                      (click)=\"sort(listProperty.property, 'asc')\"\n                                      class=\"btn btn-xs btn-block\"\n                                      closeDropDownOnClick\n                                    >\n                                      Aufsteigend sortieren\n                                    </button>\n                                    <button\n                                      (click)=\"sort(listProperty.property, 'desc')\"\n                                      class=\"btn btn-xs btn-block\"\n                                      closeDropDownOnClick\n                                    >\n                                      Absteigend sortieren\n                                    </button>\n                                  </ng-container>\n                                </div>\n                              </smallstack-overlay>\n                            </div>\n                          </div>\n                        </th>\n                        <th [resizeColumn]=\"true\">Actions</th>\n                      </tr>\n                    </ng-container>\n                    <tr class=\"rx-table-filter-row\" [ngClass]=\"{ hidden: !(filterBarVisible$ | push) }\">\n                      <!-- Filter Bar -->\n                      <th *rxIf=\"showCheckboxes$\" class=\"w-10\"></th>\n                      <th *rxIf=\"searchTextInput$\"></th>\n                      <th *rxFor=\"let lp of tableConfiguration.listProperties\">\n                        <smallstack-widget-tree\n                          *ngIf=\"lp.filterable !== false\"\n                          [widget]=\"{\n                            name: 'FilterField',\n                            data: { path: lp.property, filterSchema: lp.filterSchemaOverride }\n                          }\"\n                        ></smallstack-widget-tree>\n                      </th>\n                      <th>\n                        <button class=\"btn btn-warning btn-sm\" (click)=\"filterSearch$.next(undefined)\">l\u00F6schen</button>\n                      </th>\n                    </tr>\n                  </thead>\n                  <tbody>\n                    <tr *ngIf=\"tableData === undefined || tableData === null || tableData.length === 0\">\n                      <td colspan=\"100%\" class=\"text-center text-help m-10\">\n                        {{ (hasSearchResults$ | push) ? \"Keine Suchergebnisse\" : \"Keine Daten vorhanden\" }}\n                      </td>\n                    </tr>\n                    <!-- DATA ROWS -->\n                    <tr\n                      *cdkVirtualFor=\"let element of searchResult$; let index = index; ngForTrackById\"\n                      class=\"h-16\"\n                      data-test=\"table-row\"\n                      #rxTableRow\n                    >\n                      <td *rxIf=\"showCheckboxes$\" class=\"w-10\">\n                        <input\n                          type=\"checkbox\"\n                          class=\"checkbox checkbox-primary checkbox-sm\"\n                          [checked]=\"selectedIds.includes(element.id)\"\n                          (change)=\"toggleEntry(element.id, $event)\"\n                          attr.data-testid=\"checkbox-{{ index }}\"\n                        />\n                      </td>\n                      <td *rxIf=\"searchTextInput$\" class=\"text-center\">\n                        <span class=\"text-help\">{{ element.score }}</span>\n                      </td>\n                      <td *rxFor=\"let lp of tableConfiguration.listProperties\" [ngStyle]=\"{ flex: lp.width || 10 }\">\n                        <div *ngIf=\"lp.filterable\" class=\"absolute right-0 inline-filter invisible\">\n                          <smallstack-icon\n                            (click)=\"setInlineFilter(lp.property, element)\"\n                            name=\"filter\"\n                            class=\"opacity-60 cursor-pointer\"\n                          ></smallstack-icon>\n                        </div>\n                        <div class=\"font-bold mb-1 md:hidden\">\n                          <smallstack-i18n [data]=\"lp.title\"></smallstack-i18n>\n                        </div>\n                        <ng-container [ngSwitch]=\"lp.renderer\">\n                          <ng-container *ngSwitchCase=\"'date'\">\n                            <smallstack-date\n                              [format]=\"lp.rendererDateFormat\"\n                              [timestamp]=\"element | jsonByPath: lp.property\"\n                              style=\"white-space: nowrap\"\n                            ></smallstack-date>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'duration'\">\n                            <smallstack-duration [duration]=\"element | jsonByPath: lp.property\"></smallstack-duration>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'icon'\">\n                            <smallstack-icon\n                              size=\"24\"\n                              [alias]=\"\n                                mappingArray[lp.property][element[lp.property]]\n                                  ? mappingArray[lp.property][element[lp.property]]\n                                  : lp.defaultIcon\n                              \"\n                            ></smallstack-icon>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'image'\">\n                            <smallstack-overlay #overlay>\n                              <div class=\"card card-bordered card-compact shadow-xl bg-white\">\n                                <div class=\"card-body\">\n                                  <img [src]=\"element | jsonByPath: lp.property\" class=\"w-100\" />\n                                </div>\n                              </div>\n                            </smallstack-overlay>\n                            <img\n                              class=\"mask mask-square w-16 cursor-pointer\"\n                              [src]=\"element | jsonByPath: lp.property\"\n                              (click)=\"overlay.openOverlay()\"\n                            />\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'storeProperty'\">\n                            <smallstack-store-property\n                              [storeName]=\"lp.rendererStorePropertyStore\"\n                              [property]=\"lp.rendererStorePropertyProperty\"\n                              [modelId]=\"element | flatten: lp.property\"\n                            >\n                            </smallstack-store-property>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'i18n'\">\n                            <ng-container *ngIf=\"lp.i18nPrefix; else unPrefixed\">\n                              <smallstack-i18n\n                                [data]=\"(lp.i18nPrefix ? lp.i18nPrefix : '') + element | jsonByPath: lp.property\"\n                              ></smallstack-i18n>\n                            </ng-container>\n                            <ng-template #unPrefixed>\n                              <smallstack-i18n [data]=\"element | jsonByPath: lp.property\"></smallstack-i18n>\n                            </ng-template>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'qrCode'\">\n                            <button class=\"btn-action\" (click)=\"qrCodeDialog(element[lp.property], lp.qrCodePrefix)\">\n                              <smallstack-icon alias=\"qrcode\"></smallstack-icon>\n                            </button>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'dialog'\">\n                            <button class=\"btn-action\" (click)=\"openDialog(lp, element)\">\n                              <smallstack-icon [name]=\"lp.dialogButtonIcon\"></smallstack-icon>\n                            </button>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'link'\">\n                            <a\n                              href=\"{{ element | jsonByPath: lp.property }}\"\n                              target=\"{{ lp.openLinkInNewWindow ? '_blank' : undefined }}\"\n                            >\n                              <ng-container *ngIf=\"lp.linkLabel; else noLabel\">\n                                {{ lp.linkLabel }}\n                              </ng-container>\n                              <ng-template #noLabel>\n                                {{ element | jsonByPath: lp.property }}\n                              </ng-template>\n                            </a>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'boolean'\">\n                            <smallstack-icon\n                              name=\"checkmark--v1\"\n                              theme=\"color\"\n                              size=\"24\"\n                              *ngIf=\"(element | jsonByPath: lp.property) === true; else falsy\"\n                            >\n                            </smallstack-icon>\n                            <ng-template #falsy>\n                              <smallstack-icon name=\"delete-sign--v1\" theme=\"color\" size=\"24\"> </smallstack-icon>\n                            </ng-template>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'markdown'\">\n                            <smallstack-markdown-viewer\n                              [text]=\"element | jsonByPath: lp.property\"\n                            ></smallstack-markdown-viewer>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'googleMap'\">\n                            <div style=\"cursor: pointer; position: relative\" (click)=\"overlay.openOverlay()\">\n                              <div style=\"position: absolute; width: 100%; height: 100%; z-index: 100\"></div>\n                              <google-map\n                                [width]=\"lp.googleMapsPreviewWidth\"\n                                [height]=\"lp.googleMapsPreviewHeight\"\n                                [zoom]=\"14\"\n                                [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                [options]=\"{\n                                  gestureHandling: 'none',\n                                  disableDefaultUI: true,\n                                  styles: [\n                                    {\n                                      featureType: 'poi',\n                                      elementType: 'labels',\n                                      stylers: [{ visibility: 'off' }]\n                                    }\n                                  ]\n                                }\"\n                              >\n                                <map-marker\n                                  [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                  [clickable]=\"false\"\n                                ></map-marker>\n                              </google-map>\n                            </div>\n                            <smallstack-overlay #overlay>\n                              <mat-card appearance=\"outlined\" class=\"flex flex-col space-y-5\">\n                                <google-map\n                                  width=\"350px\"\n                                  height=\"350px\"\n                                  [zoom]=\"16\"\n                                  [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                >\n                                  <map-marker\n                                    [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                                    [clickable]=\"false\"\n                                  ></map-marker>\n                                </google-map>\n                                <button class=\"btn btn-primary\" (click)=\"overlay.closeOverlay()\">\n                                  <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n                                </button>\n                              </mat-card>\n                            </smallstack-overlay>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'widget'\">\n                            <ng-container *ngIf=\"lp.widget\">\n                              <smallstack-widget-tree\n                                *ngIf=\"lp.widgetContextType === 'full'; else propertyContext\"\n                                [widget]=\"lp.widget\"\n                                (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                                [widgetRendererOptions]=\"{\n                                  editMode$: widgetTreeService.editMode$\n                                }\"\n                                [context]=\"{ model: element }\"\n                                [globals]=\"{ model: element }\"\n                              ></smallstack-widget-tree>\n                              <ng-template #propertyContext>\n                                <smallstack-widget-tree\n                                  [widget]=\"lp.widget\"\n                                  (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                                  [widgetRendererOptions]=\"{\n                                    editMode$: widgetTreeService.editMode$\n                                  }\"\n                                  [context]=\"{ model: element | jsonByPath: lp.property }\"\n                                  [globals]=\"{ model: element }\"\n                                ></smallstack-widget-tree\n                              ></ng-template>\n                            </ng-container>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'currency'\">\n                            <smallstack-currency\n                              [iso]=\"lp.currency ? lp.currency : 'EUR'\"\n                              [cents]=\"element[lp.property]\"\n                            ></smallstack-currency>\n                          </ng-container>\n                          <ng-container *ngSwitchCase=\"'valueMapping'\">\n                            <span>{{\n                              lp.mappingArray\n                                | objectArrayValue: \"value\":element[lp.property]:\"mappedValue\":lp.defaultValue\n                            }}</span>\n                          </ng-container>\n                          <ng-container *ngSwitchDefault>\n                            {{ element | flatten: lp.property | jsonstring }}\n                          </ng-container>\n                        </ng-container>\n                      </td>\n\n                      <td class=\"flex flex-row justify-start items-center\">\n                        <ng-container *ngIf=\"data?.showDeleteButton\">\n                          <button\n                            class=\"btn-action btn-error\"\n                            [loadingFn]=\"deleteData(element)\"\n                            *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                            data-test=\"delete-entry\"\n                          >\n                            <smallstack-icon alias=\"delete\"></smallstack-icon>\n                          </button>\n                        </ng-container>\n                        <ng-container *ngIf=\"data?.showEditButton\">\n                          <button\n                            class=\"btn-action btn-primary\"\n                            [loadingFn]=\"openEditor(element)\"\n                            *showForPermission=\"(smallstackType$ | push)?.permissions?.update\"\n                            data-test=\"edit-entry\"\n                          >\n                            <smallstack-icon alias=\"edit\"></smallstack-icon>\n                          </button>\n                        </ng-container>\n                        <smallstack-widget-child\n                          [(data)]=\"data\"\n                          property=\"actionWidget\"\n                          [context]=\"{ model: element }\"\n                          (dataChange)=\"dataChange.emit($event)\"\n                        ></smallstack-widget-child>\n                      </td>\n                    </tr>\n                  </tbody>\n                  <tfoot [style.bottom]=\"footerOffset\">\n                    <tr>\n                      <td colspan=\"100%\">\n                        <div class=\"flex flex-row justify-between items-center w-full px-2 rx-table-actions\">\n                          <!-- selected id actions -->\n                          <div *rxIf=\"showCheckboxes$\" class=\"flex flex-row justify-start relative\">\n                            <!-- hide if no items are selected -->\n                            <div\n                              *rxIf=\"selectedIds.length === 0\"\n                              class=\"absolute w-full h-full top-0 left-0 z-50 bg-slate-100 opacity-80 cursor-not-allowed\"\n                            ></div>\n                            <div *ngIf=\"data.allowMultiDelete\" class=\"flex flex-row justify-start items-center gap-2\">\n                              <button\n                                class=\"btn btn-error flex flex-row gap-1 items-center text-white\"\n                                [loadingFn]=\"deleteManyData(selectedIds)\"\n                                matTooltip=\"Markierte Datens\u00E4tze l\u00F6schen\"\n                                *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                              >\n                                <smallstack-icon\n                                  alias=\"delete\"\n                                  theme=\"fluency-systems-regular\"\n                                  themeColor=\"daisyTheme.primary.textColor\"\n                                ></smallstack-icon>\n                                <smallstack-i18n data=\"@@actions.delete\"></smallstack-i18n>\n                              </button>\n                              <ng-container *rxIf=\"data.showExportButton !== false\">\n                                <button\n                                  class=\"btn btn-primary flex flex-row gap-1 items-center text-white\"\n                                  [loadingFn]=\"exportData(selectedIds)\"\n                                  matTooltip=\"Markierte Datens\u00E4tze exportieren\"\n                                  *showForPermission=\"(smallstackType$ | push)?.permissions?.readAll\"\n                                >\n                                  <smallstack-icon\n                                    name=\"export\"\n                                    theme=\"fluency-systems-regular\"\n                                    themeColor=\"daisyTheme.primary.textColor\"\n                                  ></smallstack-icon>\n                                  <smallstack-i18n data=\"@@actions.export\"></smallstack-i18n>\n                                </button>\n                              </ng-container>\n                            </div>\n                            <smallstack-widget-child\n                              property=\"listActionsComponent\"\n                              [(data)]=\"data\"\n                              [context]=\"{selectedIds}\"\n                              [widgetTags]=\"[WidgetTag.ICON, WidgetTag.CONTAINER]\"\n                              (dataChange)=\"dataChange.emit($event)\"\n                            ></smallstack-widget-child>\n                          </div>\n                          <!-- information -->\n                          <div class=\"justify-center items-center text-help\" *rxLet=\"totalCount$; let totalCount\">\n                            {{ totalCount }} Datens\u00E4tze insgesamt<span\n                              *rxIf=\"totalCount !== tableData.length || hasSearchResults$ || filterSearch$\"\n                            >\n                              | {{ tableData.length }} Suchergebnisse</span\n                            ><span *ngIf=\"selectedIds?.length > 0\"> | {{ selectedIds.length }} markiert</span></div\n                          >\n                          <div class=\"flex flex-row gap-2\">\n                            <button\n                              class=\"btn btn-primary flex flex-row gap-1 items-center\"\n                              [loadingFn]=\"reload(false)\"\n                              (longPress)=\"reload(true)()\"\n                              data-test=\"reload\"\n                            >\n                              <smallstack-icon\n                                alias=\"refresh\"\n                                theme=\"fluency-systems-regular\"\n                                themeColor=\"daisyTheme.primary.textColor\"\n                              ></smallstack-icon>\n                              <smallstack-i18n data=\"@@actions.reload\"></smallstack-i18n>\n                            </button>\n                            <ng-container *showForPermission=\"(smallstackType$ | push)?.permissions?.create\">\n                              <button\n                                *ngIf=\"tableConfiguration?.showCreateButton !== false\"\n                                class=\"btn btn-primary flex flex-row gap-1 items-center\"\n                                [loadingFn]=\"openEditor()\"\n                                data-test=\"create\"\n                              >\n                                <smallstack-icon\n                                  alias=\"plus\"\n                                  theme=\"fluency-systems-regular\"\n                                  themeColor=\"daisyTheme.primary.textColor\"\n                                ></smallstack-icon>\n                                <smallstack-i18n data=\"@@actions.create\"></smallstack-i18n>\n                              </button>\n                            </ng-container>\n                          </div>\n                        </div>\n                      </td>\n                    </tr>\n                  </tfoot>\n                </table>\n              </cdk-virtual-scroll-viewport>\n            </div>\n          </div>\n        </ng-container>\n      </ng-template>\n    </ng-container>\n  </ng-container>\n  <ng-template #widgetNotConfigured>\n    <div style=\"height: 60px\" class=\"flex flex-col justify-center items-center\">\n      <i><smallstack-i18n data=\"@@widgets.dataTable.errors.notConfiguredYet\"></smallstack-i18n></i>\n    </div>\n  </ng-template>\n</div>\n", styles: ["table{border-collapse:separate;border-spacing:0}th{@apply p-1 overflow-hidden border-r border-r-white bg-slate-100 h-10 sticky text-sm;}thead{@apply sticky top-0 z-50;}thead tr{@apply bg-white;}thead tr th{@apply border-b border-b-white;}tfoot{@apply sticky bottom-0 z-50 bg-slate-100;}tfoot tr{@apply bg-white;}tfoot tr td{@apply border-t border-t-white bg-slate-100;}tbody tr{@apply bg-white;}tbody tr:nth-child(odd){@apply bg-slate-50;}tbody tr:hover{@apply bg-slate-100;}td{@apply overflow-hidden p-2 h-16;}.rx-table-filter-row ::ng-deep .input{@apply input-sm font-light;}.rx-table-filter-row ::ng-deep .btn{@apply btn-sm;}.rx-table-filter-row ::ng-deep .menu{@apply menu-xs;}.rx-table-actions ::ng-deep .btn{@apply btn-sm;}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.MatDialog }, { type: i2.NotificationService }, { type: i3.RouterUtilService }, { type: i1$1.FrontendTypeRegistry }, { type: i3.BreakpointService }, { type: i1$1.RxCollectionService }, { type: i3.FrontendSchemaService }, { type: i5.ActivatedRoute }]; }, propDecorators: { height: [{
                type: HostBinding,
                args: ["style.height"]
            }], viewPort: [{
                type: ViewChild,
                args: [CdkVirtualScrollViewport, { static: false }]
            }] } });

export { DataTableV3WidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-data-table-v3-widget.component-61c85692.mjs.map
