import { NgSwitch, NgSwitchCase } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import { RxPush } from '@rx-angular/template/push';
import * as i1 from '@smallstack/rx-components';
import { SyncStatus } from '@smallstack/rx-components';
import { IconComponent } from '@smallstack/theme-components';
import { BaseWidgetComponent } from '@smallstack/widget-core';
import { debounce, interval, map } from 'rxjs';

class SyncStatusWidgetComponent extends BaseWidgetComponent {
    constructor(syncStatusService) {
        super();
        this.syncStatusService = syncStatusService;
        this.SyncStatus = SyncStatus;
        this.longSync$ = this.syncStatusService.status$.pipe(debounce((val) => interval(val === SyncStatus.syncing ? 500 : 0)) // eliminates the "syncing" status if it is only for a short time (e.g. messages polling while in dev mode)
        );
        this.syncingCollectionNames$ = this.syncStatusService.syncingCollections$.pipe(map((collections) => collections.map((collection) => collection.collectionName).join(", ")));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: SyncStatusWidgetComponent, deps: [{ token: i1.SyncStatusService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: SyncStatusWidgetComponent, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-container [ngSwitch]=\"longSync$ | push\">\n  <ng-container *ngSwitchCase=\"SyncStatus.syncing\">\n    <div\n      class=\"tooltip tooltip-left tooltip-primary\"\n      attr.data-tip=\"\u00C4nderungen werden synchronisiert: {{ syncingCollectionNames$ | push }}\"\n    >\n      <smallstack-icon\n        size=\"32\"\n        name=\"database\"\n        theme=\"fluency-systems-regular\"\n        themeColor=\"daisyTheme.primary.textColor\"\n        class=\"animate-pulse\"\n        [badge]=\"syncStatusService.syncingCollectionCount$ | push\"\n      ></smallstack-icon>\n    </div>\n  </ng-container>\n</ng-container>\n", dependencies: [{ kind: "pipe", type: RxPush, name: "push" }, { kind: "directive", type: NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: SyncStatusWidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [RxPush, NgSwitch, NgSwitchCase, IconComponent], template: "<ng-container [ngSwitch]=\"longSync$ | push\">\n  <ng-container *ngSwitchCase=\"SyncStatus.syncing\">\n    <div\n      class=\"tooltip tooltip-left tooltip-primary\"\n      attr.data-tip=\"\u00C4nderungen werden synchronisiert: {{ syncingCollectionNames$ | push }}\"\n    >\n      <smallstack-icon\n        size=\"32\"\n        name=\"database\"\n        theme=\"fluency-systems-regular\"\n        themeColor=\"daisyTheme.primary.textColor\"\n        class=\"animate-pulse\"\n        [badge]=\"syncStatusService.syncingCollectionCount$ | push\"\n      ></smallstack-icon>\n    </div>\n  </ng-container>\n</ng-container>\n" }]
        }], ctorParameters: function () { return [{ type: i1.SyncStatusService }]; } });

export { SyncStatusWidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-sync-status-widget.component-293a7a07.mjs.map
